import { CommonModule } from '@angular/common';
import { WchLoggerFactory } from '@ibm-wch-sdk/ng-api';
export { WchLoggerFactory as ɵa } from '@ibm-wch-sdk/ng-api';
import { Injectable, NgModule, Optional, SkipSelf } from '@angular/core';
import { Category } from 'typescript-logging';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class TypescriptLoggerService {
    constructor() { }
    /**
     * @param {?} name
     * @return {?}
     */
    create(name) {
        /** @type {?} */
        const cat = new Category(name);
        /**
         * @param {?} msg
         * @param {...?} data
         * @return {?}
         */
        function info(msg, ...data) {
            // dispatch to the category
            cat.info({ msg, data });
        }
        /**
         * @param {?} msg
         * @param {...?} data
         * @return {?}
         */
        function error(msg, ...data) {
            // dispatch to the category
            cat.error(msg, new Error(msg));
        }
        /**
         * @param {?} msg
         * @param {...?} data
         * @return {?}
         */
        function warn(msg, ...data) {
            // dispatch to the category
            cat.warn({ msg, data });
        }
        return { info, error, warn };
    }
}
TypescriptLoggerService.decorators = [
    { type: Injectable }
];
/** @nocollapse */
TypescriptLoggerService.ctorParameters = () => [];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class WchTypescriptLoggingModule {
    /*
       * This contructor prevents the module from being imported multiple times.
       *
       * @param parentModule
       */
    /**
     * @param {?} parentModule
     */
    constructor(parentModule) {
        // do not allow recursive includes
        if (parentModule) {
            throw new Error('WchTypescriptLoggingModule is already loaded. Import it in the AppModule only');
        }
    }
    /*
       * Returns the preconfigured module
       *
       * @param aService  the service
       */
    /**
     * @return {?}
     */
    static forRoot() {
        return {
            ngModule: WchTypescriptLoggingModule,
            providers: [
                { provide: WchLoggerFactory, useClass: TypescriptLoggerService }
            ]
        };
    }
}
WchTypescriptLoggingModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule]
            },] }
];
/** @nocollapse */
WchTypescriptLoggingModule.ctorParameters = () => [
    { type: WchTypescriptLoggingModule, decorators: [{ type: Optional }, { type: SkipSelf }] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { WchTypescriptLoggingModule, TypescriptLoggerService as ɵb };

//# sourceMappingURL=ibm-wch-sdk-typescript-logger.js.map