import { CommonModule } from '@angular/common';
import { WchLoggerFactory } from '@ibm-wch-sdk/ng-api';
export { WchLoggerFactory as ɵa } from '@ibm-wch-sdk/ng-api';
import { Injectable, NgModule, Optional, SkipSelf } from '@angular/core';
import { Category } from 'typescript-logging';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var TypescriptLoggerService = /** @class */ (function () {
    function TypescriptLoggerService() {
    }
    /**
     * @param {?} name
     * @return {?}
     */
    TypescriptLoggerService.prototype.create = /**
     * @param {?} name
     * @return {?}
     */
    function (name) {
        /** @type {?} */
        var cat = new Category(name);
        /**
         * @param {?} msg
         * @param {...?} data
         * @return {?}
         */
        function info(msg) {
            var data = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                data[_i - 1] = arguments[_i];
            }
            // dispatch to the category
            cat.info({ msg: msg, data: data });
        }
        /**
         * @param {?} msg
         * @param {...?} data
         * @return {?}
         */
        function error(msg) {
            var data = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                data[_i - 1] = arguments[_i];
            }
            // dispatch to the category
            cat.error(msg, new Error(msg));
        }
        /**
         * @param {?} msg
         * @param {...?} data
         * @return {?}
         */
        function warn(msg) {
            var data = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                data[_i - 1] = arguments[_i];
            }
            // dispatch to the category
            cat.warn({ msg: msg, data: data });
        }
        return { info: info, error: error, warn: warn };
    };
    TypescriptLoggerService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    TypescriptLoggerService.ctorParameters = function () { return []; };
    return TypescriptLoggerService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var WchTypescriptLoggingModule = /** @class */ (function () {
    /*
     * This contructor prevents the module from being imported multiple times.
     *
     * @param parentModule
     */
    function WchTypescriptLoggingModule(parentModule) {
        // do not allow recursive includes
        if (parentModule) {
            throw new Error('WchTypescriptLoggingModule is already loaded. Import it in the AppModule only');
        }
    }
    /*
     * Returns the preconfigured module
     *
     * @param aService  the service
     */
    /*
       * Returns the preconfigured module
       *
       * @param aService  the service
       */
    /**
     * @return {?}
     */
    WchTypescriptLoggingModule.forRoot = /*
       * Returns the preconfigured module
       *
       * @param aService  the service
       */
    /**
     * @return {?}
     */
    function () {
        return {
            ngModule: WchTypescriptLoggingModule,
            providers: [
                { provide: WchLoggerFactory, useClass: TypescriptLoggerService }
            ]
        };
    };
    WchTypescriptLoggingModule.decorators = [
        { type: NgModule, args: [{
                    imports: [CommonModule]
                },] }
    ];
    /** @nocollapse */
    WchTypescriptLoggingModule.ctorParameters = function () { return [
        { type: WchTypescriptLoggingModule, decorators: [{ type: Optional }, { type: SkipSelf }] }
    ]; };
    return WchTypescriptLoggingModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { WchTypescriptLoggingModule, TypescriptLoggerService as ɵb };

//# sourceMappingURL=ibm-wch-sdk-typescript-logger.js.map